/*
system.js is contains scripts to handle home, system
*/

var ADMIN_SERVER_URL = "ServerAdmin";
var SHOW_HOME_REFRESH_TIME = 6000;

var showDivHome = false;
var showDivHomeTimeout;
var showHomeInterval = 0;

function showHomeMenu(thisObj, index) {

    renderHomeMenuExplicitly();
    //Initial Firing
    if (showHomeInterval == 0) {
        showHome();
        showHomeInterval = setInterval('showHome()', SHOW_HOME_REFRESH_TIME);
    }
}

function showHome() {

    var body_xml = ' <ns1:getStatus  xmlns:ns1="http://org.apache.axis2/xsd"/>\n';
    var callURL = serverURL + "/" + SERVER_ADMIN_STRING + "/" + "getStatus";

    if (document.getElementById("divHome").style.display == 'none' &&
        showDivHome) {
        showDivHome = false;
        clearInterval(showHomeInterval);
        showHomeInterval = 0;
        // this is to counter if focus to divHome is vanished.
        return false;

    }

    send("getStatus", body_xml, "", callURL, "", false, showHomeCallback);

}

function showHomeCallback() {
    stopWaitAnimation();
    if (!onError()) {
        return;
    }

    callbackhelper("system_status.xsl", document.getElementById("divHome"));

    showDivHome = true;
    // tivially at this point divHome is inline
}

function manageSystem(thisObj, index) {

    if (thisObj && index) {
        renderSelectedMenuItem(thisObj,index);
        gatherHistoryObject(thisObj.id, index);
    }

    var xsltFileName = "system_info.xsl";
    var body_xml = ' <ns1:getServerData xmlns:ns1="http://org.apache.axis2/xsd"/>\n';

    var callURL = serverURL + "/" + SERVER_ADMIN_STRING ;
    send("getServerData", body_xml, xsltFileName, callURL, document.getElementById("divManageSystem"), false);

}

function saveServer() {
    var body_xml = '<req:saveRequest xmlns:req="http://org.apache.axis2/xsd"/>\n';

    var callURL = serverURL + "/" + ADMIN_SERVER_URL ;
    send("save", body_xml, "", callURL, "", false, saveServerCallBack);
}

function saveServerCallBack() {
    if (!onError()) {
        return;
    }
    alertMessage("Server state was saved successfuly");
}

function stoppingRefreshingMethodsHook() {
    // initializing the showDiv variable
    clearInterval(showHomeInterval);
    showDivHome = false;
    showHomeInterval = 0;
    clearInterval(showDivInterval);
    showDivStatistics = false;
    showDivInterval = 0;
    // stoping refreshing methods from listService and listServiceGroup
    clearInterval(listServiceDataRequestInterval);
    showListServiceDataDiv = false;
    listServiceDataRequestInterval = 0;

    clearInterval(listServiceGroupsRequestInterval);
    showListServcieGroupDiv = false;
    listServiceGroupsRequestInterval = 0;

    //stop refresing for viewLogs
    clearInterval(showDivViewLogsInterval);
    showDivViewLogs = false;
    showDivViewLogsInterval = 0;

    clearInterval(showGraphDivInterval);
    showGraphDivHome = false;
    showGraphDivInterval = 0;
}

