var retyped_pw_error = "Password and re-entered password do not match!";

var currentUserName;

function globalSecuritySettings(thisObj,index) {

    if (thisObj && index) {
        renderSelectedMenuItem(thisObj,index);
        gatherHistoryObject(thisObj.id, index);
    }
    
    var objDiv = document.getElementById("divUsers");

    var strHTML =  "<div style=\"align:left;\"><h2>Security Management</h2>"+
                   "<div id='formset'>"+
                   "<form>" +
                   "<fieldset>" +
                   "<legend>User and Role Management</legend>"+
                   "<h4><a href='#' onclick='manageRole(); return false;'><nobr/>Role Management</nobr></a></h4><p>Create new roles and edit existing roles.</p><p>&nbsp;</p>" +
                   "<h4><a href='#' onclick='manageUser(); return false;'><nobr>User Management</nobr></a></h4><p>Create new users, assign roles to users and edit existing users.</p>"+
                   "</fieldset>"+
                   "</form>"+
                   "</div></div>";

    objDiv.innerHTML = strHTML;
    showOnlyOneMain(objDiv);
}
function manageUsers() {
    globalSecuritySettings();
}

function manageRole() {
    var xsltFileName = "role.xsl";

    var body_xml = '<req:getRoleNamesAndDescriptionsRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' </req:getRoleNamesAndDescriptionsRequest>\n';

    var callURL = serverURL + "/" + "UserAdmin" + "/" ;
    send("getRoleNamesAndDescriptions", body_xml, xsltFileName, callURL, document.getElementById("divManageRole"), false);
}


function manageUser() {
    var xsltFileName = "user.xsl";

    var body_xml = '<req:getUserNamesRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' </req:getUserNamesRequest>\n';

    var callURL = serverURL + "/" + "UserAdmin" + "/" ;
    send("getUserNames", body_xml, xsltFileName, callURL, document.getElementById("divManageUser"), false);
}

function editUsers(userName, userRole) {
    var strHTML1 =  "<h4><a href='#' onclick='javascript:manageUsers(); return false;'>Users</a>&nbsp;&gt;&nbsp;<a href='#' onclick='javascript:manageUser(); return false;'>User Management</a>&nbsp;&gt;&nbsp;Edit User</h4>" +
                  "<div id='formset'><form>";

    //regex for userName

    userName = userName.replace(/\xA7/g,"'"); // ASCII Value  \xA7 --> §

    currentUserName = userName;

    // Change role. We do not allow changing of role of the admin user
    var strHTML2 = (userName == 'admin')? "" :
                   "<fieldset>" +
                  "<legend>Assign role to user '" + userName + "'</legend>" +
                  "<div><label>User Role</label>" + "<select id='editUser_RoleCombo'></select></div>" +
                  "<div class='buttonrow'><input type='button' onclick='addUserWtihRole(document.getElementById(\"editUser_RoleCombo\"));' value='Assign'/></div>" +
                  "</fieldset>";

    // change password
    var strHTML3 = "<fieldset>" +
                  "<legend>Change password of user '" + userName + "'</legend>" +
                  "<div><label>Old Password<font color='red'>*</font></label>" + "<input type='password' id='editUser_old_password'/></div>" +
                  "<div><label>New Password<font color='red'>*</font></label>" + "<input type='password' id='editUser_password'/></div>" +
                  "<div><label>Re-enter New Password<font color='red'>*</font></label>" + "<input type='password' id='editUser_password_re'/></div>" +
                  "<div class='buttonrow'><input type='button' onclick='saveEditUserPw(document.getElementById(\"editUser_password\"), document.getElementById(\"editUser_password_re\"),document.getElementById(\"editUser_old_password\"));' value='Change Password'/></div>" +
                  "</fieldset>" +
                  "</form></div>";

    var strHTML = strHTML1 + strHTML2 + strHTML3;
    document.getElementById("divEditUser").innerHTML = strHTML;
    showOnlyOneMain(document.getElementById("divEditUser"));

    var body_xml = '<req:getRoleNamesRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' </req:getRoleNamesRequest>\n';

    var callURL = serverURL + "/" + "UserAdmin" + "/" ;
    send("getRoleNames", body_xml, "", callURL, "", false, editUsersCallback(userRole));
}

function editUsersCallback(defaultRole) {
    if (!onError()) {
        return;
    }
    var comboToLoad = document.getElementById('editUser_RoleCombo');
    if (comboToLoad != null) {
        var data = getBody(xhReq.responseXML);
        var rets = data.getElementsByTagName("return");
        var len = rets.length;
        var count;
        for (count = 0; count < len; count++) {
            comboToLoad.options[count] = new Option(rets[count].firstChild.nodeValue);
            comboToLoad.options[count].value = rets[count].firstChild.nodeValue;
            if (rets[count].firstChild.nodeValue == defaultRole) {
                comboToLoad.options[count].selected = true;
            }
        }
    }
}
function saveEditUser(userNameObj, roleCombo) {

    var un = userNameObj.value;
    var roleName = roleCombo.value;
    var body_xml = '<req:editUserRoleRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <req:username>' + un + '</req:username>\n' +
                   ' <req:role>' + roleName + '</req:role>\n' +
                   ' </req:editUserRoleRequest>\n';

    var callURL = serverURL + "/" + "UserAdmin" + "/" ;
    send("editUserRole", body_xml, "", callURL, "", false, saveEditUserCallback);

}

function saveEditUserPw(pw, pw_re, old_pw) {

    var un = currentUserName;
    var pwv = pw.value;
    if(old_pw.value == null || trim(old_pw.value) == ""){
        alertWarning("Old password cannot be empty");
        return false;
    }
    if (pwv  == null || trim(pwv) == "") {
        alertWarning('New Password cannot be Empty');
        return false;
    }
    var pw_rev = pw_re.value;
    if (trim(pwv) != trim(pw_rev)) {
        alertWarning(retyped_pw_error);
        return false;
    }
    var body_xml = '<req:editUserPasswordRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <req:oldPassword><![CDATA[' + (old_pw.value) + ']]></req:oldPassword>\n' +
                   ' <req:username><![CDATA[' + un + ']]></req:username>\n' +
                   ' <req:password><![CDATA[' + pwv + ']]></req:password>\n' +
                   ' </req:editUserPasswordRequest>\n';

    var callURL = serverURL + "/" + "UserAdmin" + "/" ;
    send("editUserPassword", body_xml, "", callURL, "", false, saveEditUserPwCallback);
}

function saveEditUserCallback() {
    if (!onError()) {
        return;
    }
    var data = getBody(xhReq.responseXML);

    if (data.getElementsByTagName("return")[0].firstChild.nodeValue == "true") {
        alertMessage("Editing user was successful.");
    }
    manageUser();
}

function saveEditUserPwCallback() {
    if (!onError()) {
        return;
    }
    var data = getBody(xhReq.responseXML);

    if (data.getElementsByTagName("return")[0].firstChild.nodeValue == "true") {
        alertMessage("Update password was successful.");
        manageUser();
    } else {
        alertWarning("Password update failed. Please recheck your old password.");
    }
}

//add user - used in user management
function addUser(userName, password, password_re, role, description) {
    var un = userName.value;
    var pw = password.value;
    var dp = description.value;
    if(un == null || trim(un) == ""){
        alertWarning("Please enter a valid username.");
        return false;
    }
    if(pw == null || trim(pw) == ""){
        alertWarning("Please enter the password.");
        return false;
    }

    var pw_re = password_re.value;
    if (pw != pw_re) {
        alertWarning(retyped_pw_error);
        return false;
    }
    var rl = role[role.selectedIndex].text;
    if(rl == null){
       rl = role[role.selectedIndex].value;
    }
    if(dp == null || trim(dp) == ""){
        dp = "";
    }
    var body_xml = '<req:addUserRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <req:username><![CDATA[' + un + ']]></req:username>\n' +
                   ' <req:password><![CDATA[' + pw + ']]></req:password>\n' +
                   ' <req:role><![CDATA[' + rl + ']]></req:role>\n' +
                   ' <req:description><![CDATA[' + dp + ']]></req:description>\n' +
                   ' </req:addUserRequest>\n';

    var callURL = serverURL + "/" + "UserAdmin" + "/" ;
    role.value = "";
    password.value = "";
    password_re.value = "";
    role.value = "";
    send("addUser", body_xml, "", callURL, "", false, addUserCallback);
}

function addUserCallback() {
    if (!onError()) {
        return;
    }
    showResponseMessage(xhReq);
    manageUser();
}

function addRoleCallBack() {
    if (!onError()) {
        return;
    }

    var data = getBody(xhReq.responseXML);
    var text = data.getElementsByTagName('return')[0];

    if (text.firstChild.nodeValue == 'true'){
        alertMessage("User role was added successfully.");
    }else {
        alertWarning("User role already exists.");
    }
    manageRole();
}

function addRole(role,description) {
    var rolename = role.value;
    var roleDescription = description.value;
    if(rolename == null || trim(rolename) == ""){
        alertWarning("Please enter a valid Role name.");
        return false;
    }
    if(roleDescription == null || trim(roleDescription) == ""){
        roleDescription = "";
    }
    if (trim(rolename) != '') {
        var xsltFileName = "role.xsl";
        var body_xml = '<req:addRoleRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                       ' <req:role><![CDATA[' + rolename + ']]></req:role>\n' +
                       ' <req:description><![CDATA[' + roleDescription + ']]></req:description>\n' +
                       ' </req:addRoleRequest>\n';

        var callURL = serverURL + "/" + "UserAdmin" + "/" ;
        role.value = "";
        send("addRole", body_xml, xsltFileName, callURL, document.getElementById("divAddRole"), false, addRoleCallBack);
    } else {
        alertWarning("Please specify the user role to add.");
    }

    //refresh page
    //manageRole();
}

// loading the user names for the combo
function loadUserListComboBox() {
    var body_xml = '<req:getRoleNamesRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' </req:getRoleNamesRequest>\n';

    var callURL = serverURL + "/" + "UserAdmin" + "/" ;
    send("getRoleNames", body_xml, "", callURL, "", false, loadUserListCallback);

}

//load user list callback.
function loadUserListCallback() {
    if (!onError()) {
        return;
    }
    var comboToLoad = document.getElementById('roleSelectBox');
    var data = getBody(xhReq.responseXML);
    var rets = data.getElementsByTagName("return");
    var len = rets.length;
    var count;
    for (count = 0; count < len; count++) {
        comboToLoad.options[count] = new Option(rets[count].firstChild.nodeValue);
        comboToLoad.options[count].value = rets[count].firstChild.nodeValue;
    }

}
function loadUsersComboBox() {
    var xsltFileName = "user.xsl";
    var body_xml = '<req:getUsersRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' </req:getUsersRequest>\n';

    var callURL = serverURL + "/" + "UserAdmin" + "/" ;
    send("getUsers", body_xml, "", callURL, "", false, loadUsersCallback);
}

function loadUsersCallback() {
    if (!onError()) {
        return;
    }
    var comboToLoad = document.getElementById('serviceUserName');
    var data = getBody(xhReq.responseXML);
    var rets = data.getElementsByTagName("return");
    var len = rets.length;
    var count;
    for (count = 0; count < len; count++) {
        comboToLoad.options[count] = new Option(rets[count].firstChild.nodeValue);
        comboToLoad.options[count].value = rets[count].firstChild.nodeValue;
    }
}

function deleteUser(user) {

    user = user.replace(/\xA7/g,"'");

    if (user == 'admin') {
        alertWarning("You cannot delete the default admin account!");
        return false;
    }
    var deleteIt= confirm("Do you really want to delete user "+ user +"?");
    if (deleteIt) {
        var body_xml = '<req:deleteUserRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                       '<req:deleteUser><![CDATA[' + user + ']]></req:deleteUser>\n'+
                       '</req:deleteUserRequest>\n';

        var callURL = serverURL + "/" + "UserAdmin" + "/" ;
        send("deleteUser", body_xml, "", callURL, "", false, deleteUserCallback);
    }
}

function deleteUserCallback() {
    if (!onError()) {
        return;
    }
    alertMessage("User was deleted successfully.");
    manageUser();
}

function deleteRole(user,role) {

    user = user.replace(/\xA7/g,"'");
    role = role.replace(/\xA7/g,"'");

    if (user == 'admin') {
        alertWarning("You cannot modify the default admin account settings!");
        return false;
    }
    var deleteIt= confirm("Do you really want to unassign role "+ role +" from user " + user + "?");
    if (deleteIt) {
        var body_xml = '<req:deleteRoleFromUserRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                       '<req:username><![CDATA[' + user + ']]></req:username>\n'+
                       '<req:role><![CDATA[' + role + ']]></req:role>\n'+
                       '</req:deleteRoleFromUserRequest>\n';

        var callURL = serverURL + "/" + "UserAdmin" + "/" ;
        send("deleteRoleFromUser", body_xml, "", callURL, "", false, deleteRoleCallback);
    }
}

function deleteRoleCallback() {
    if (!onError()) {
        return;
    }
    var data = getBody(xhReq.responseXML);

    if (data.getElementsByTagName("return")[0].firstChild.nodeValue == "true") {
        alertMessage("Unassigned user from role successfully.");
    } else {
        alertWarning("Role Cannot be removed since a user should have at least one role.<br/>" +
                    "Please assign another role to this user before trying removing this role.");
    }
    manageUser();
}

function addUserWtihRole(role) {

    if (currentUserName == 'admin') {
        alertWarning("You cannot modify the default admin account settings!");
        return false;
    }


    rl = role[role.selectedIndex].value;

    var body_xml = '<req:addUserWithRoleRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   '<req:username><![CDATA[' + currentUserName + ']]></req:username>\n'+
                   '<req:role><![CDATA[' + rl + ']]></req:role>\n'+
                   '</req:addUserWithRoleRequest>\n';

    var callURL = serverURL + "/" + "UserAdmin" + "/" ;
    send("addUserWithRole", body_xml, "", callURL, "", false, addUserWtihRoleCallback);

}

function addUserWtihRoleCallback() {
    if (!onError()) {
        return;
    }
    alertMessage("Role successfully assigned to user");
    manageUser();
}

function deleteRoleCompletely(role) {
    role = role.replace(/\xA7/g,"'");

    if (role == 'admin') {
        alertWarning("You cannot delete the default admin role!");
        return false;
    }
    var deleteIt= confirm("Do you really want to delete role "+ role +"?");
    if (deleteIt) {
        var body_xml = '<req:deleteRoleCompletelyRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                       '<req:role><![CDATA[' + role + ']]></req:role>\n'+
                       '</req:deleteRoleCompletelyRequest>\n';

        var callURL = serverURL + "/" + "UserAdmin" + "/" ;
        send("deleteRoleCompletely", body_xml, "", callURL, "", false, deleteRoleCompletelyCallback);
    }
}

function deleteRoleCompletelyCallback() {
    if (!onError()) {
        return;
    }
    var data = getBody(xhReq.responseXML);

    var deleteStatement = data.getElementsByTagName("return")[0].firstChild.nodeValue;
    alertMessage(deleteStatement);

    manageRole();

}

