var xhtml = "http://www.w3.org/1999/xhtml";

var GLOBAL_SERVICE_STRING = "GlobalAdmin";
var SERVER_ADMIN_STRING = "ServerAdmin";
var SERVICE_GROUP_ADMIN_STRING = "ServiceGroupAdmin";
var MODULE_ADMIN_STRING = "ModuleAdmin";
var LOGGING_SERVICE_STRING = "LoggingService";

var SECURITY_SCENARIO_CONFIG_ADMIN = "SecurityScenarioConfigAdmin";

var CRYPTO_ADMIN_STRING = "CryptoAdmin";
/*
@deprecate
*/
var RAMPART_INFLOW_CONFIG_ADMIN_STRING = "RampartInflowConfigAdmin";
/*
@deprecate
*/
var RAMPART_OUTFLOW_CONFIG_ADMIN_STRING = "RampartOutflowConfigAdmin";

var SERVICE_CONTEXT = "/soap";

function init() {
    URL = locationString.substring(0, locationString.lastIndexOf('/'));

    defaultURL = URL;

    if (URL.indexOf('https') == -1) {
        //	alert("You can only access the management console through https. \n The default https port for WSO2 WSAS is " + httpsPort + ".");
        var newURL = "https" + URL.substring(URL.indexOf('://'), URL.lastIndexOf(':') + 1) +
                     httpsPort;
        var httpsAlertText =
                "You can only access the management console through https. <br/> The default https port for WSO2 WSAS is " +
                httpsPort + "." +
                "<br/> If the default settings have not been changed the management console can be accessed using the following URL.<br/>" +
                "<a href='" + newURL + "'>" + newURL + "</a>";
        alertInternal(httpsAlertText, WARNING_MESSAGE);

        //	alert(newURL);
        //	browser.redirect(newURL);
    }

    admIndex = URL.lastIndexOf('/admin');
    if (admIndex != -1) {
        URL = URL.substring(0, URL.lastIndexOf('/admin'));
    }

    // Service URL parsing
    serverURL = URL + SERVICE_CONTEXT;

    if (getCookie("userName") != null) {
        serviceGroupId = getCookie("serviceGroupId");
        userName = getCookie("userName");
        finishLogin();
    } else {
        document.formLogin.txtUserName.focus();
    }
}

/* changing css on runtime related to Menu Items*/

var selectedMenuItem = null;
var selectedMenuItemClass = null;

function renderSelectedMenuItem(obj, index) {
    if (obj != null && index) {
        if (selectedMenuItem != null) {
            selectedMenuItem.className = selectedMenuItemClass;
        }
        selectedMenuItem = obj;
        selectedMenuItemClass = selectedMenuItem.className;
        selectedMenuItem.className = MenuClassFactory.getClass(index);
    }

}

function renderHomeMenuExplicitly() {
    var obj = document.getElementById('menu_home_link_id');
    if (obj != null) {
        if (selectedMenuItem != null) {
            selectedMenuItem.className = selectedMenuItemClass;
        }
        selectedMenuItem = obj;
        selectedMenuItemClass = selectedMenuItem.className;
        selectedMenuItem.className = MenuClassFactory.getClass(0);
    }
}

/*Object that uses to execute Second run of the '*' file upload method*/

function FileExcutor() {
}

/*Encounter for bug
FileExcutor.execute = foo; is the method should be called with extraStoreDirUUID(uuid);
*/
new FileExcutor();

/*This is the method that's gonna invoked by CertificateFileUploadExecutor for WS Call*/
function extraStoreDirUUID(uuid) {
    FileExcutor.execute(uuid);
}

/*
the method storeDiv(divName, isReloadDiv); when isReloadDiv is true,
div object is not added to the histry stack of the browser.

security.js is architectured in a way, that it will load from a main
div and populate other inner divs base on Web Service calls.

Thus, the method transformationWithoutHistory(xslFile,objDiv) will transform any
internal div without adding it to the browserstack

*/

function transformationWithoutHistory(xslFile, objDiv) {
    var data = getBody(xhReq.responseXML);
    processXML(data, xslFile, objDiv);
    showOnlyOneMain(objDiv, true);

}

function showRestartServer(thisObj, index) {

    if (thisObj && index) {
        renderSelectedMenuItem(thisObj,index);
        gatherHistoryObject(thisObj.id, index);
    }

    /*
    restartServer with xsl
    */

    var tmpTransformationNode;

    if (window.XMLHttpRequest && !isIE()) {
        tmpTransformationNode =
        document.implementation.createDocument("", "restartServer", null);
    } else if (window.ActiveXObject) {
        tmpTransformationNode = new ActiveXObject("Microsoft.XmlDom");
        var sXml = "<restartServer></restartServer>";
        tmpTransformationNode.loadXML(sXml);
    }
    var objDiv = document.getElementById("divRestartServer");
    processXML(tmpTransformationNode, "restart_server.xsl", objDiv);
    showOnlyOneMain(objDiv);

}

/*Menu rendering*/

function MenuClassFactory() {
}

/* indexes and elements have a one to one relationship*/
MenuClassFactory.classElements =
        new Array(
        'menu_home_link_class_clicked',
        'menu_services_class_clicked',
        'menu_modules_class_clicked',
        'menu_security_class_clicked',
        'menu_transports_class_clicked',
        'menu_keystore_class_clicked',
        'menu_logs_class_clicked',
        'menu_restart_server_class_clicked',
        'menu_system_class_clicked',
        'menu_stat_class_clicked',
        'menu_log_class_clicked',
        'menu_tracer_class_clicked',
        'menu_axis_config_class_clicked');

function getMenuFactoryClassElements(index) {
    return MenuClassFactory.classElements[index];
}

MenuClassFactory.getClass = getMenuFactoryClassElements;

/** A function that is called whenever the user
 presses the back or forward buttons. This
 function will be passed the newLocation,
 as well as any history data we associated
 with the location. */
function handleHistoryChange(newLocation, historyData) {
    var actDivName = newLocation.substring(3, newLocation.length);
    var shouldDisplay = false;
    var divId;
    var divIndex
    // This is done to stop the screen from jumping about.
    if (actDivName.indexOf("divHome") > -1 ) {
        showHomeMenu();
        return;
    }
    if (historyData != null) {
        var objValue = historyData.menuObj;
        if (objValue != undefined) {
            var divIdIndex = objValue.indexOf(":");

            divId = objValue.substring(0, divIdIndex);
            divIndex = objValue.substring(divIdIndex + 1, objValue.length);

            shouldDisplay = true;


        }

    }

    // lastHash from mf_ui; main.js
    if (shouldDisplay) {
        renderSelectedMenuItem(document.getElementById(divId), divIndex);
    }
    // This is must
    lastHash = newLocation;

    if (actDivName.indexOf("viewLogs") > -1 && shouldDisplay) {
        showViewLogs();

    } else if (actDivName.indexOf("divListServiceGroups") > -1 && shouldDisplay) {
        startServices();

    } else if (actDivName.indexOf("divStatistics") > -1 && shouldDisplay) {
        monitorSystemMenu();
    } else {
        eval("showOnlyOneMain(document.getElementById('" + actDivName + "'), true)");
    }
    return;

}


function gatherHistoryObject(objId, index) {
    mainMenuObjectId = objId;
    mainMenuObjectIndex = index;
}
/*
return false ; validation fails
return true ; validation passes
*/
function parseParameterName(value) {
    var regexParamName = /[<>"'&;]+/;

    if (regexParamName.test(value)) {
        return false;
    } else {
        return true;
    }
}

