<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:output method="html"/>

    <xsl:template match="ns1:getKeyStoresResponse" xmlns:ns1="http://org.apache.axis2/xsd">
    	<div id="formset">
    		<fieldset style="border: none">
                <xsl:choose>
                        <xsl:when test="return">
                            <table class="styled">
                                <thead>
                                <tr>
                                    <th>Name</th>
                                    <th>Type</th>
                                    <th>Actions</th>
                                </tr>
                                </thead>
                                <tbody>
                                <xsl:for-each select="return">
                                    <tr>
                                        <td>
                                            <xsl:attribute name="title"><xsl:value-of select="keyStoreFilename"/></xsl:attribute>
                                            <xsl:value-of select="keyStoreName"/>
                                        </td>
                                        <td>
                                            <xsl:value-of select="keyStoreType"/>
                                        </td>
                                        <td>
                                            <nobr>
                                                <a id="import_link">
                                                    <xsl:attribute name="href">#</xsl:attribute>
                                                    <xsl:attribute name="title">Import Certificate</xsl:attribute>
                                                    <xsl:attribute name="onClick">javascript:showImportCertificate('<xsl:value-of select="keyStoreName"/>'); return false;</xsl:attribute>
                                                    <xsl:attribute name="alt">Import</xsl:attribute>
                                                    <xsl:text>&#160;&#160;&#160;&#160;</xsl:text>
                                                </a>
                                                <xsl:text>&#160;&#160;</xsl:text>
                                                <a href="#" id="cancel_link">
                                                    <xsl:attribute name="onClick">javascript:deleteKeyStore('<xsl:value-of select="keyStoreName"/>'); return false;</xsl:attribute>
                                                    <xsl:attribute name="title">Remove key store <xsl:value-of select="keyStoreName"/> </xsl:attribute>
                                                    <xsl:attribute name="alt">Remove</xsl:attribute>
                                                    &#160;&#160;&#160;&#160;
                                                </a>
                                            </nobr>
                                        </td>
                                    </tr>
                                </xsl:for-each>
                            </tbody>
                            </table>
                    </xsl:when>
                </xsl:choose>
			</fieldset>
		</div>
    </xsl:template>
 </xsl:stylesheet>
