/*
services.js is manipulate the service related scripts.
*/


/////////////////////////////////////////
// Globle variables services

var serviceSpecificName = "";
var lastUsedServiceId = "";
////////////////////////////////////////

////////////////////////////////////////
// Globle variable for operation


var serviceOperationParameters = "";
var OPERATION_ADMIN_SERVER_URL = "OperationAdmin";
var lastOperationUsed = "";

////////////////////////////////////////


////////////////////////////////////////
// Module Specific

var moduleSpanToUse = "";
var moduleComboName = "";

var setModuleVersion = "";
var setModuleName = "";
var MODULE_ADMIN_STRING = "ModuleAdmin";
var MODULE_ADMIN_SERVER_URL = "ModuleAdmin";
var setOperationName = "";
///////////////////////////////////////


//////////////////////////////////////
// Policy specific

var lastUsedServiceVersion = "";


////////////////////////////////////


//////////////////////////////////////////
// stub generation

var genFileKey = "";
var mainservicPortComboValue = "";
var mainServiceBindingName = "";

///////////////////////////////////////////

var defaultHttpPort;
var defaultBrowserHost;
var defaultopenWindowHTTPURL;
var SERVICE_REFRESH_TIME = 10000;

// This holds thread's id, which is positive
var listServiceDataRequestInterval = 0;
var showListServiceDataDiv = false;

var listServiceGroupsRequestInterval = 0;
var showListServcieGroupDiv = false;
//////////////////////////////////////////

var operationNameForEngagedOperationHandlers;

// getters and setters

function getServiceSpecificName() {
    return serviceSpecificName;
}

function getServiceOperationParameters() {
    return serviceOperationParameters;
}


function listServiceGroups() {
    var body_xml = '<ns1:listServiceGroups  xmlns:ns1="http://org.apache.axis2/xsd">\n' +
                   ' </ns1:listServiceGroups>\n';

    var callURL = serverURL + "/" + SERVICE_GROUP_ADMIN_STRING + "/" + "listServiceGroups";

    if (document.getElementById("divListServiceGroups").style.display == 'none' &&
        showListServcieGroupDiv) {
        showListServcieGroupDiv = false;
        clearInterval(listServiceGroupsRequestInterval);
        listServiceGroupsRequestInterval = 0;
        // this is to counter if focus to divHome is vanished.
        return false;

    }
    send("listServiceGroups", body_xml, "", callURL, "", false, listServiceGroupsCallback);
}

function listServiceGroupsCallback() {
    if (!onError()) {
        return;
    }
    showListServcieGroupDiv = true;
//    callbackhelper("list_services.xsl", document.getElementById("divListServiceGroups"));
    transformationWithoutHistory("list_services_info.xsl", document.getElementById("listServicesInformation"));
    //showing the non refreshing Div
    document.getElementById('formsetWrapper').style.display = 'inline';
    loadFaultyServices();

}

function loadFaultyServices() {
    var body_xml = '<req:faultyServicesRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' </req:faultyServicesRequest>\n';

    var callURL = serverURL + "/" + "ServiceAdmin" ;
    send("faultyServices", body_xml, "", callURL, "", false, loadFaultyServicesCallback);


}

function loadFaultyServicesCallback() {
    if (!onError()) {
        return;
    }
    var obj = document.getElementById('faultyServices');

    var data = getBody(xhReq.responseXML);
    var intValue = data.getElementsByTagName("return")[0].firstChild.nodeValue;

    if (intValue == '0') {
        obj.style.display = 'none';
    } else {
        obj.style.display = 'inline';
        obj.innerHTML =
        '<h4><a href="#" onClick="javascript:listFaultyArchives(); return false;"><b><i>[' + intValue + '] faulty service(s)</a></i></b></h4>';
    }

}

function deleteServiceGroupCallBack() {
    if (!onError()) {
        return;
    }

    cursorWait();
    setTimeout("showAARGenerationCompleteMsg('The Service Group has been successfully deleted')",
            1000);

}

function deleteServiceGroup(serviceGroupName) {
    var delete_to = confirm("Do you really want to delete [" + serviceGroupName + "].aar ?");
    if (delete_to == true) {
        /* stopping the refreshing first */
        stoppingRefreshingMethodsHook();
        var body_xml = '<req:deleteServiceGroupRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                       ' <req:serviceGroupName>' + serviceGroupName + '</req:serviceGroupName>\n' +
                       ' </req:deleteServiceGroupRequest>\n';

        var callURL = serverURL + "/" + "ServiceAdmin" ;
        send("deleteServiceGroup", body_xml, "", callURL, document.getElementById("divListServiceGroups"), false, deleteServiceGroupCallBack);
    } else {
        //        alertMessage("Aborted Deletion !");
        return false;
    }
}
function showAARGenerationCompleteMsg(msg) {
    cursorClear();
    alertMessage(msg);
    showServiceInitializer();
}

function listServiceDataRefresh(serviceName) {
    /*stopping the refreshing first */
    stoppingRefreshingMethodsHook();

    serviceSpecificName = serviceName;
    listServiceData(serviceName);

    if (listServiceDataRequestInterval == 0) {
        listServiceDataRequestInterval = setInterval(function() {
            listServiceData(getServiceSpecificName());
        }, SERVICE_REFRESH_TIME);
    }


}

function listServiceData(serviceName) {
    var body_xml = '<req:getServiceDataRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <req:serviceName>' + serviceName + '</req:serviceName>\n' +
                   ' </req:getServiceDataRequest>\n';

    var callURL = serverURL + "/" + "ServiceAdmin" + "/" ;

    if (document.getElementById("divListServiceData").style.display == 'none' &&
        showListServiceDataDiv) {
        showListServiceDataDiv = false;
        clearInterval(listServiceDataRequestInterval);
        listServiceDataRequestInterval = 0;
        // this is to counter if focus to divHome is vanished.
        return false;

    }

    send("getServiceData", body_xml, "", callURL, "", false,listServiceDataCallback);

}

function listServiceDataCallback() {
    if (!onError()) {
        return;
    }

    showListServiceDataDiv = true;
    callbackhelper("list_service_main_info.xsl",document.getElementById("divListServiceData"));
}

function activationOfService(serviceStatus) {
    var body_xml = '';
    var callURL = serverURL + "/" + "ServiceAdmin" ;
    var soapAction = "";
    if (serviceStatus == true) {
        body_xml = '<req:startServiceRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <req:serviceName>' + serviceSpecificName + '</req:serviceName>\n' +
                   ' </req:startServiceRequest>\n';
        soapAction = "startService";
    }
    if (serviceStatus == false) {
        body_xml = '<req:stopServiceRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <req:serviceName>' + serviceSpecificName + '</req:serviceName>\n' +
                   ' </req:stopServiceRequest>\n';
        soapAction = "stopService";

    }
    send(soapAction, body_xml, "", callURL, "", false, activationOfServiceCallback);
}

function activationOfServiceCallback() {
    if (!onError()) {
        return;
    }
    cursorWait();
    setTimeout("showlistSericeData()", 1000);
}


function showlistSericeData() {
    cursorClear();
    listServiceData(serviceSpecificName);
    var obj = document.getElementById("divListServiceData");
    showOnlyOneMain(obj);
}

function listAllOperations(serviceName) {

    /*stopping the refreshing first */
    stoppingRefreshingMethodsHook();

    serviceSpecificName = serviceName;
    lastUsedServiceId = serviceName;
    // need to see the output to write the xsl
    var xsltFileName = "";
    var body_xml = '<ns1:listAllOperations xmlns:ns1="http://org.apache.axis2/xsd">\n' +
                   ' <arg0>' + serviceName + '</arg0>\n' +
                   ' <arg1>' + serviceName + '</arg1>\n' +
                   ' </ns1:listAllOperations>\n';

    var callURL = serverURL + "/" + "OperationAdmin" + "/" + "listAllOperations";
    send("listAllOperations", body_xml, "", callURL, "", false, listAllOperationsCallback);
}

function listAllOperationsCallback() {
    if (!onError()) {
        return;
    }
    callbackhelper("list_operations.xsl", document.getElementById("divListAllOperations"));
    showlistOperationsHeader(document.getElementById('listOperationsHeader'));
}

function engageModulePerService(serviceName) {

    /*stopping the refreshing first */
    stoppingRefreshingMethodsHook();

    lastUsedServiceId = serviceName;
    var objDiv = document.getElementById("divEngageModule");
    var strHTML = "<h4><a href='#' onClick='javascript:showServiceInitializer(); return false;'>Services</a>&nbsp;&gt;&nbsp;<a href='#' onClick='javascript:listServiceData(\"" + serviceName + "\"); return false;'>" + serviceName + "</a>&nbsp;&gt;&nbsp;Engage Modules</h4>" +
                  "<fieldset style='border: none;'>" +
                  "<div id='formset'>" +
                  "<form>" +
                  "<fieldset>" +
                  "<legend>Engage module to service " + serviceName + "</legend>" +
                  "<div><label>Module</label><span id='engageModulePerServiceCombo'></span></div>" +
                  "<div class='buttonrow'><input type='button' onclick='javascript:engageModulePerServiceExec(\"" + serviceName + "\", document.getElementById(\"cmbEngageModulePerServiceCombo\").value);' value='Engage'/></div>" +
                  "</fieldset>" +
                  "</form>" +
                  "<div id='modulesPerServiceOnly' style='display:inline; position: relative; top: 20px;'></div>" +
                  "<div id='modulesEngagedOnParent' style='display:inline; position: relative; top: 20px;'></div>" +
                  "<div id='globleModulesOnService' style='display:inline; position: relative; top: 20px;'></div>" +
                  "</div>" +
                  "</fieldset>";

    var body_xml = '<req:listServiceModulesRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <req:serviceName>' + serviceName + '</req:serviceName>\n' +
                   ' </req:listServiceModulesRequest>\n';

    objDiv.innerHTML = strHTML;
    showOnlyOneMain(objDiv);

    var callURL = serverURL + "/" + "ModuleAdmin" + "/" ;
    send("listServiceModules", body_xml, "", callURL, "", false, engageModulePerServiceCombo);

    // get Globalling engaged Modules

}

function engageModulePerServiceCombo() {
    if (!onError()) {
        return;
    }
    var xsltFileName = "list_engaged_modules_per_service.xsl";
    var objDiv = document.getElementById("modulesPerServiceOnly");
    var data = getBody(xhReq.responseXML);
    processXML(data, xsltFileName, objDiv);
    //alert("Callback fired");
    //    getGlobalModuleCombo(document.getElementById("engageModulePerServiceCombo"), "cmbEngageModulePerServiceCombo");
    getGlobalModuleComboService(document.getElementById("engageModulePerServiceCombo"), "cmbEngageModulePerServiceCombo");


}

function getGlobalModuleComboService(cmbSpan, cmbName) {
    moduleSpanToUse = cmbSpan;
    moduleComboName = cmbName;
    //    alert("Global module getting function called");

    var body_xml = '<ns1:listModules  xmlns:ns1="http://org.apache.axis2/xsd"/>\n';

    var callURL = serverURL + "/" + MODULE_ADMIN_STRING + "/" + "listModules";
    send("listModules", body_xml, "", callURL, "", false, getGlobalModuleComboPerServiceCallback);

}

function getGlobalModuleComboPerServiceCallback() {

    if (!onError()) {
        return;
    }
    var data = getBody(xhReq.responseXML);

    //    alert("XSL = " + (new XMLSerializer()).serializeToString(data));

    var strHTML = "<select id='" + moduleComboName + "'>";
    var rets = data.getElementsByTagName("return");
    var len = rets.length;
    var count;
    var moduleVersion;
    for (count = 0; count < len; count++) {
        if (rets[count].getElementsByTagName("moduleversion")[0].firstChild != null) {
            moduleVersion = rets[count].getElementsByTagName("moduleversion")[0].firstChild.nodeValue;
        } else {
            moduleVersion = "";
        }
        displayModuleVersion = (moduleVersion == "" ? "" : ("-" + moduleVersion));
        strHTML += "<option value='" + rets[count].getElementsByTagName("moduleid")[0].firstChild.nodeValue + '||' + moduleVersion + "'>" + rets[count].getElementsByTagName("modulename")[0].firstChild.nodeValue + displayModuleVersion + "</option>\n";
    }
    strHTML += "</select>"

    moduleSpanToUse.innerHTML = strHTML;

    //globally engage

    body_xml = '<req:listGloballyEngagesModulesRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
               ' </req:listGloballyEngagesModulesRequest>\n';
    callURL = serverURL + "/" + "ModuleAdmin" + "/";
    send("listGloballyEngagesModules", body_xml, "", callURL, "", false, listGloballyEngageModulesPerServiceCallback);
}

function listGloballyEngageModulesPerServiceCallback() {

    if (!onError()) {
        return;
    }

    var xsltFileName = "list_engaged_modules_per_service.xsl";
    var objDiv = document.getElementById("globleModulesOnService");
    var data = getBody(xhReq.responseXML);
    processXML(data, xsltFileName, objDiv);

    // Engaged Modules this service's parent

    var body_xml = '<req:listServicesParentEngagedModulesRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   '<serviceName>' + lastUsedServiceId + '</serviceName>\n' +
                   '</req:listServicesParentEngagedModulesRequest>\n';
    callURL = serverURL + "/" + "ModuleAdmin" + "/";

    send("listServicesParentEngagedModules", body_xml, "", callURL, "", false, listServicesParentEngagedModulesCallback);

}

function listServicesParentEngagedModulesCallback() {
    if (!onError()) {
        return;
    }
    var xsltFileName = "list_engaged_modules_per_service.xsl";
    var objDiv = document.getElementById("modulesEngagedOnParent");
    var data = getBody(xhReq.responseXML);
    processXML(data, xsltFileName, objDiv);

}


function engageModulePerServiceExec(serviceName, moduleName) {
    var moduleVersion = moduleName.substring(moduleName.indexOf('||') + 2, moduleName.length);
    lastUsedServiceId = serviceName;
    setModuleVersion = moduleVersion;
    moduleName = moduleName.substring(0, moduleName.indexOf('||'));
    //	alert("engageModulePerServiceExec Called with serviceName = " +serviceName + " || moduleName = " + moduleName + " ||| moduleVersion = " + moduleVersion);
    setModuleName = moduleName;
    var body_xml = '<req:engageModuleForServiceRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <req:moduleid>' + moduleName + '</req:moduleid>\n' +
                   ' <req:moduleversion>' + moduleVersion + '</req:moduleversion>\n' +
                   ' <req:service_id>' + serviceName + '</req:service_id>\n' +
                   ' <req:service_version></req:service_version>\n' +
                   ' </req:engageModuleForServiceRequest>\n';

    var callURL = serverURL + "/" + "ModuleAdmin" + "/" ;
    send("engageModuleForService", body_xml, "", callURL, "", false, engageModulePerServiceCallBack);


}

function engageModulePerServiceCallBack() {
    if (!onError()) {
        return;
    }

    var data = getBody(xhReq.responseXML);
    var text = data.getElementsByTagName('return')[0];

    alertMessage(text.firstChild.nodeValue);

    setTimeout(function() {
        engageModulePerService(lastUsedServiceId);
    }, 1000);
    //    engageModulePerService(lastUsedServiceId);
}


function getServiceSpecficParametersForConfig(serviceName) {

    /*stopping the refreshing first */
    stoppingRefreshingMethodsHook();

    if (serviceName == null) {
        if (!onError()) {
            return;
        }
        serviceName = lastUsedServiceId;
    } else {
        lastUsedServiceId = serviceName;
        serviceSpecificName = serviceName;
    }
    var body_xml = '<req:getDeclaredServiceParametersRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <req:serviceId>' + serviceName + '</req:serviceId>\n' +
                   ' <req:serviceVersion>' + serviceName + '</req:serviceVersion>\n' +
                   ' </req:getDeclaredServiceParametersRequest>\n';

    var callURL = serverURL + "/" + "ServiceAdmin" ;
    send("getDeclaredServiceParameters", body_xml, "", callURL, "", false, getServiceSpecficParametersForConfigCallback);

}


function getServiceSpecficParametersForConfigCallback() {
    if (!onError()) {
        return;
    }
    callbackhelper("list_service_param_edit.xsl", document.getElementById("divGetServiceSpecficParametersForConfig"));
    showlistServiceParamEditHeader(document.getElementById('listServiceParamEditHeader'));
}

////////////////////////////////////////////////////////////////////////////////
//                            <wsp:Policy> 				      //
////////////////////////////////////////////////////////////////////////////////


function getServiceSpecificPoliciesForConfig(serviceId, serviceVersion) {

    /*stopping the refreshing first */
    stoppingRefreshingMethodsHook();

    lastUsedServiceId = serviceId;
    lastUsedServiceVersion = serviceVersion;

    serviceSpecificName = serviceId;
    // is this necessary ?

    var xsltFileName = "list_service_policies_edit.xsl";
    var body_xml = '<ns1:getPoliciesRequest xmlns:ns1="http://org.apache.axis2/xsd">' +
                   '<ns1:serviceId>' + serviceId + '</ns1:serviceId>' +
                   '<ns1:serviceVersion>' + serviceVersion + '</ns1:serviceVersion>' +
                   '</ns1:getPoliciesRequest>';

    var callURL = serverURL + "/" + "ServiceAdmin";

    send("getPolicies", body_xml, "", callURL, "", false, getServiceSpecificPoliciesForConfigCallBack);

}


function getServiceSpecificPoliciesForConfigCallBack() {
    if (!onError()) {
        return;
    }
    callbackhelper("list_service_policies_edit.xsl", document.getElementById("divServices"));
    showlistPolicyInfoEditHeader(document.getElementById('listPolicyInfoEditHeader'));
    var data = getBody(xhReq.responseXML);
    var children = data.getElementsByTagName('return');
    var textBox;
    for (i = 0; i < children.length; i++) {
        eval("textBox=document.getElementById('" + (i + 1) + "_service_policy_text_')");
        textBox.value = xmlSerializerToString(children[i].firstChild.firstChild);
    }
}

function setServiceSpecificPolicyFromConfig(serviceId, serviceVersion, policyValue) {
    var body_xml = '<my:setPolicy xmlns:my="http://org.apache.axis2/xsd">' +
                   '<my:serviceId>' + serviceId + '</my:serviceId>' +
                   '<my:version>' + serviceVersion + '</my:version>' +
                   '<my:policyString><![CDATA[' + policyValue + ']]></my:policyString>' +
                   '</my:setPolicy>';

    var callURL = serverURL + "/" + "ServiceAdmin";
    send("setPolicy", body_xml, "", callURL, "", false, setServiceSepcificPolicyFromConfigCallBack);
}

function setServiceSepcificPolicyFromConfigCallBack() {

    if (!onError()) {
        return;
    }
    alertMessage("Service policy successfully updated.");
}

/////////////////////////////////////////////////////// Policy Ends


/*
Callback is available via list_services_meta_info.xsl;
*/
function isServiceWSDLAvailable(callback) {

    /*stopping the refreshing first */
    stoppingRefreshingMethodsHook();

    var body_xml = '<req:isWSDLAvailable xmlns:req="http://org.apache.axis2/xsd">\n' +
                   '<req:serviceName>' + getServiceSpecificName() + '</req:serviceName>\n' +
                   ' </req:isWSDLAvailable>\n';

    var callURL = serverURL + "/" + "WSDLInfoService" + "/" ;
    send("isWSDLAvailable", body_xml, "", callURL, "", false, callback);

}

function isServiceWSDLAvailableTryItCallback() {
    if (!onError()) {
        return;
    }
    var data = getBody(xhReq.responseXML);
    //One click Jar download
    isServiceWSDLAvailableHelperTryIt(data);


}
function isServiceWSDLAvailableOneClickJarDownloadCallback() {
    if (!onError()) {
        return;
    }
    var data = getBody(xhReq.responseXML);
    //One click Jar download
    isServiceWSDLAvailableHelperGenerateClient(data);


}

function isServiceWSDLAvailableHelperGenerateClient(data) {
    var rets = data.getElementsByTagName("return")[0];
    var returnTextValue = rets.firstChild.nodeValue;
    if (returnTextValue == 'true') {
        //process
        stubGenerationMetaInfo();
    } else if (returnTextValue == 'false') {
        // no proecessing
        alertMessage("Client generation could not continue due to WSDL not being available or\n" +
                     " the message receiver not being RPCMessageReceiver.");

    } else {
        alertWarning(lable + "  Operations Couldnot be continued");

    }

}

function isServiceWSDLAvailableHelperTryIt(data) {
    var rets = data.getElementsByTagName("return")[0];
    var returnTextValue = rets.firstChild.nodeValue;
    if (returnTextValue == 'true') {
        //process
        dynamicClientGeneration();
    } else if (returnTextValue == 'false') {
        // no proecessing
        alertMessage("DHTML generation could not continue due to WSDL not being available or\n" +
                     " the message receiver not being RPCMessageReceiver.");

    } else {
        alertWarning(lable + "  Operations Couldnot be continued");

    }

}

function stubGenerationMetaInfo() {
    var body_xml = '<req:listServicesAndPortsRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   '<req:serviceName>' + getServiceSpecificName() + '</req:serviceName>\n' +
                   ' </req:listServicesAndPortsRequest>\n';

    var callURL = serverURL + "/" + "WSDLInfoService" + "/" ;
    send("listServicesAndPorts", body_xml, "", callURL, "", false, stubGenerationMetaInfoCallback);

}

function stubGenerationMetaInfoCallback() {
    if (!onError()) {
        return;
    }
    callbackhelper("stub_meta_info.xsl", document.getElementById("divStubGeneration"));
    showstubGenMetaInfo(document.getElementById('stubGenMetaInfo'));
}

function stubGenerationSOAPRequest(packageNameObj, invocationStyleObj,
                                   generateTestCasesObj, databindingMethodObj,
                                   unpackClassesObj, serviceBindingName,
                                   serviceBindingPortObj,unwrapObj) {

    var packageName = packageNameObj.value;
    var serviceName = serviceSpecificName;
    var invocationStyle = invocationStyleObj[invocationStyleObj.selectedIndex].value;
    var generateTestCases = generateTestCasesObj[generateTestCasesObj.selectedIndex].value;
    var databindingMethod = databindingMethodObj[databindingMethodObj.selectedIndex].value;
    var unpackClasses = unpackClassesObj[unpackClassesObj.selectedIndex].value;
    var serviceBindingPort = serviceBindingPortObj[serviceBindingPortObj.selectedIndex].value;
    var unwrap = unwrapObj[unwrapObj.selectedIndex].value;

    var pattern = /^[a-zA-Z](([a-zA-Z_]+)([a-zA-Z0-9_]?)\.?)+[a-z0-9_]$/;
    if (packageName == null || trim(packageName) == '') {
        alertWarning("Package name is mandatory");
        return;
    }
    if (!pattern.test(packageName)) {
        alertWarning("Package name is not valid under Java package naming conventions");
        return;
    }

    var body_xml = '<req:generateRequest xmlns:req="http://wsdl2code.service.admin.wsas.wso2.org">\n' +
                   ' <service>' + serviceName + '</service>\n' +
                   ' <packageName>' + packageName + '</packageName>\n' +
                   ' <invocationStyle>' + invocationStyle + '</invocationStyle>\n' +
                   ' <generateTestCase>' + generateTestCases + '</generateTestCase>\n' +
                   ' <databindingMethod>' + databindingMethod + '</databindingMethod>\n' +
                   ' <unpackClasses>' + unpackClasses + '</unpackClasses>\n' +
                   ' <serviceBindingName>' + serviceBindingName + '</serviceBindingName>\n' +
                   ' <servicePortName>' + serviceBindingPort + '</servicePortName>\n' +
                   ' <unwrap>' + unwrap + '</unwrap>\n' +
                   ' </req:generateRequest>\n';

    var callURL = serverURL + "/" + "JavaClientGeneratorService" ;
    cursorWait();
    send("generate", body_xml, "", callURL, document.getElementById("divSystemConfiguration"), false, generateCallBack);
}

function generateCallBack() {
    cursorClear();
    if (!onError()) {
        return;
    }
    //response will be a link and it will call the download dialog
    var data = getBody(xhReq.responseXML);

    var responseTextValue = data.getElementsByTagName("return")[0].firstChild.nodeValue;

    var _url = self.location.href.substring(0, locationString.lastIndexOf('/') + 1);

    window.location = _url + responseTextValue;
}


function loadUsersComboBox() {
    var xsltFileName = "user.xsl";
    var body_xml = '<req:getUsersRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' </req:getUsersRequest>\n';

    var callURL = serverURL + "/" + "UserAdmin" + "/" ;
    send("getUsers", body_xml, "", callURL, "", false, loadUsersCallback);
}

function loadRolesComboBox() {
    //    var xsltFileName = "role.xsl";
    var body_xml = '<req:getRoleNamesAndDescriptionsRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' </req:getRoleNamesAndDescriptionsRequest>\n';

    var callURL = serverURL + "/" + "UserAdmin" + "/" ;
    send("getRoleNamesAndDescriptions", body_xml, "", callURL, "", false, loadRolesComboBoxCallback);
}

function loadRolesComboBoxCallback() {
    if (!onError()) {
        return;
    }
    var comboToLoad = document.getElementById('serviceRoleName');
    var data = getBody(xhReq.responseXML);
    //    alert((new XMLSerializer()).serializeToString(data));
    var rets = data.getElementsByTagName("return");
    var len = rets.length;
    var count;
    for (count = 0; count < len; count++) {
        var roleCollection = rets[count].getElementsByTagName("role");
        comboToLoad.options[count] = new Option(roleCollection[0].firstChild.nodeValue);
        comboToLoad.options[count].value = roleCollection[0].firstChild.nodeValue;
    }
	showOnlyOneMain(document.getElementById("divListRoles"));
}

function loadUsersCallback() {
    if (!onError()) {
        return;
    }
    var comboToLoad = document.getElementById('serviceUserName');
    var data = getBody(xhReq.responseXML);
    var rets = data.getElementsByTagName("return");
    var len = rets.length;
    var count;
    for (count = 0; count < len; count++) {
        comboToLoad.options[count] = new Option(rets[count].firstChild.nodeValue);
        comboToLoad.options[count].value = rets[count].firstChild.nodeValue;
    }
}

/* @depricated */
function serviceUNameToeknAuth(){
	listUsers1();
}


function loadRolesComboBox1() {
    //    var xsltFileName = "role.xsl";
    var body_xml = '<req:getRoleNamesAndDescriptionsRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' </req:getRoleNamesAndDescriptionsRequest>\n';

    var callURL = serverURL + "/" + "UserAdmin" + "/" ;
    send("getRoleNamesAndDescriptions", body_xml, "", callURL, "", false, loadRolesComboBoxCallback1);
}

function loadRolesComboBoxCallback1() {
    if (!onError()) {
        return;
    }
    var comboToLoad = document.getElementById('serviceRoleName');
    var data = getBody(xhReq.responseXML);
    //    alert((new XMLSerializer()).serializeToString(data));
    var rets = data.getElementsByTagName("return");
    var len = rets.length;
    var count;
    for (count = 0; count < len; count++) {
        var roleCollection = rets[count].getElementsByTagName("role");
        comboToLoad.options[count] = new Option(roleCollection[0].firstChild.nodeValue);
        comboToLoad.options[count].value = roleCollection[0].firstChild.nodeValue;
    }
	//showOnlyOneMain(document.getElementById("divListRoles"));
}


function getOperationSpecficParameters(operation) {
    serviceOperationParameters = operation;

    showOperationSpecificStatistics();
}

//@private
function getOperationSpecficParameters0(){

    var body_xml = '<req:getDeclaredOperationParametersRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   '<serviceName>' + getServiceSpecificName() + '</serviceName>\n' +
                   '<operationName>'+ getServiceOperationParameters() +'</operationName>\n' +
                   '</req:getDeclaredOperationParametersRequest>\n';

    var callURL = serverURL + "/" + "OperationAdmin" + "/" ;
    send("getDeclaredOperationParameters", body_xml, "", callURL, "", false, getOperationSpecficParameters0Callback);

}

function getOperationSpecficParameters0Callback() {
    if (!onError()) {
        return;
    }

    transformationWithoutHistory("list_service_param.xsl", document.getElementById("listOperationsParameters"));

}

function showOperationSpecificStatistics() {
    var body_xml = '<req:getOperationStatisticsRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   '<serviceName>' + getServiceSpecificName() + '</serviceName>\n' +
                   '<operationName>' + getServiceOperationParameters() + '</operationName>\n' +
                   '</req:getOperationStatisticsRequest>\n';

    var callURL = serverURL + "/" + "OperationAdmin" + "/" ;
    send("getOperationStatistics", body_xml, "", callURL, "", false, showOperationSpecificStatisticsCallback);

}

function showOperationSpecificStatisticsCallback() {
    if (!onError()) {
        return;
    }
    callbackhelper("show_param_statistics.xsl",document.getElementById("divGetOperationSpecficParameters"));

    showlistOperationParamAndStatisticsEditHeader(document.getElementById('listServiceParamHeader'));

    getOperationSpecficParameters0();

}


function getServiceGroupSpecificParameters(group) {
    var xsltFileName = "list_service_group_param.xsl";
    var body_xml = '<req:getDeclaredServiceGroupParametersRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <req:service_group_id>' + group + '</req:service_group_id>\n' +
                   ' <req:group_version></req:group_version>\n' +
                   ' </req:getDeclaredServiceGroupParametersRequest>\n';

    var callURL = serverURL + "/" + "ServiceGroupAdmin" + "/" ;
    send("getDeclaredServiceGroupParameters", body_xml, xsltFileName, callURL,
            document.getElementById("divServiceGroupParams"), false);

}

function getOperationSpecficParametersForConfig(operation) {
    if (operation == null) {
        if (!onError()) {
            return;
        }
        operation = serviceOperationParameters;
    } else {
        serviceOperationParameters = operation;
    }
    var body_xml = '<req:getDeclaredOperationParametersRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <req:service_id>' + getServiceSpecificName() + '</req:service_id>\n' +
                   ' <req:operation_id>' + operation + '</req:operation_id>\n' +
                   ' </req:getDeclaredOperationParametersRequest>\n';

    var callURL = serverURL + "/" + OPERATION_ADMIN_SERVER_URL ;
    send("getDeclaredOperationParameters", body_xml, "", callURL, "", false,
            getOperationSpecficParametersForConfigCallback);

}

function getOperationSpecficParametersForConfigCallback() {
    if (!onError()) {
        return;
    }
    callbackhelper("list_operation_params_edit.xsl",
            document.getElementById("divGetOperationSpecficParametersForConfig"));
    showlistOperationParamEditHeader(document.getElementById('listOperationParamEditHeader'));
}


var cur_module_number_ser = 0;
var global_arrayOfNames_ser = null;
var global_arrayOfValues_ser = null;
//operation parameter update procedure
//loop through the two arrays and pass through each and every parameter

//function processOperationParameterConfigUpdate(cur, arrayOfNames, arrayOfValues) {
//	if (cur == null){
//		if (!onError()) {
//			return;
//		}
//		cur = cur_module_number_ser + 1;
//	}
//	cur_module_number_ser = cur;
//	if (arrayOfNames == null){
//		arrayOfNames = global_arrayOfNames_ser;
//	} else {
//		global_arrayOfNames_ser =arrayOfNames;
//	}
//	if (arrayOfValues == null){
//		arrayOfValues = global_arrayOfValues_ser;
//	} else {
//		global_arrayOfValues_ser = arrayOfValues;
//	}
//    if (cur < arrayOfNames.length) {
//        processSingleOperationParameterConfigEntry(
//                lastUsedServiceId,
//                serviceOperationParameters,
//                arrayOfNames[cur],
//                arrayOfValues[cur], processOperationParameterConfigUpdate);
//    } else {
//	    updateServiceOperationInfoDisplay("Update successful");
//	}
//    /* Show the user that the update was successful after the server has been successfuly
//    called for all parameters. */
//
//}

//display the messages for the modules
function updateServiceOperationInfoDisplay(message) {
    document.getElementById('operationConfigUpdate').innerHTML = message;
}

//add operation specific parameter
function addOperationParameter() {
    var newParam = getUserInput();
    if (newParam != null) {
        processSingleOperationParameterConfigEntry(
                lastUsedServiceId,
                serviceOperationParameters,
                newParam[0],
                newParam[1], getOperationSpecficParametersForConfig);
    }
}
//todo
function processMultipleOperationParameterConfigEntry(serviceId,
                                                      operationId,
                                                      parameterNamesObj,
                                                      parameterValueObj) {
    var paramElements = '';
    for (var i = 0 ; i < parameterNamesObj.length; i++) {
        paramElements += '<parameter locked="false" name="' + parameterNamesObj[i] + '"><![CDATA[' + parameterValueObj[i] +']]></parameter>\n';
    }
    var body_xml = '<ns1:setOperationParameters xmlns:ns1="http://org.apache.axis2/xsd">' +
                   '<ns1:serviceId>' + serviceId + '</ns1:serviceId>' +
                   '<ns1:operationId>' + operationId + '</ns1:operationId>' +
                   '<ns1:groupVersion></ns1:groupVersion>' +
                   paramElements +
                   '</ns1:setOperationParameters>';

    var callURL = serverURL + "/" + OPERATION_ADMIN_SERVER_URL;
    send("setOperationParameters", body_xml, "", callURL, "", false, processMultipleOperationParameterConfigEntryCallback);



}

function processMultipleOperationParameterConfigEntryCallback() {
    if (!onError()) {
        return;
    }

    alertMessage("Operation parameters were successfully updated.");

    getOperationSpecficParametersForConfig(getServiceOperationParameters());

}

//add a single operation parameter entry
function processSingleOperationParameterConfigEntry(
        serviceId,
        operationId,
        parameterName,
        parameterValue, operation_callback) {

    if (!parseParameterName(parameterName)) {
        alertMessage("Parameter name contains an invalid character");
        return false;
    }

    var body_xml = '<ns1:setOperationParameterRequest xmlns:ns1="http://org.apache.axis2/xsd">' +
                   '<ns1:service_id>' + serviceId + '</ns1:service_id>' +
                   '<ns1:operation_id>' + operationId + '</ns1:operation_id>' +
                   '<ns1:group_version></ns1:group_version>' +
                   '<parameter locked="false" name="' + parameterName + '"><![CDATA[' + parameterValue + ']]></parameter>' +
                   '</ns1:setOperationParameterRequest>';

    var callURL = serverURL + "/" + OPERATION_ADMIN_SERVER_URL;
    send("setOperationParameter", body_xml, "", callURL, "", false, operation_callback);
}
//end of  processSingleOperationParameterConfigEntry
function engageModulePerOperation(operationName) {
    lastOperationUsed = operationName;
    var objDiv = document.getElementById("divEngageModulePerOperation");
    var strHTML = "<h4><a href='#' onClick='javascript:showServiceInitializer(); return false;'>Services</a>&nbsp;&gt;&nbsp;<a href='#' onClick='javascript:listServiceData(\"" + getServiceSpecificName() + "\"); return false;'>" + getServiceSpecificName() + "</a>" + "&nbsp;&gt;&nbsp;<a href='#' onClick='javascript:listAllOperations(\"" + getServiceSpecificName() + "\"); return false;'>Operation[" + lastOperationUsed + "]</a>&nbsp;&gt;&nbsp;Engage Module" + "</h4>" +
                  "<fieldset style='border: none;'>" +
                  "<div id='formset'>" +
                  "<form>" +
                  "<fieldset>" +
                  "<legend>Engage module to operation <font color='blue'>" + operationName + "</font></legend>" +
                  "<div><label>Module</label><span id='engageModulePerOperationCombo'></span></div>" +
                  "<div class='buttonrow'><input type='button' onclick='javascript:engageModulePerOperationExec(\"" + operationName + "\", document.getElementById(\"cmbEngageModulePerOperationCombo\").value);' value='Engage'/></div>" +
                  "</fieldset>" +
                  "</form>" +
                  "<div id='modulesPerOperation' style='display:inline; position: relative; top: 20px;'></div>" +
                  "<div id='modulesPerService' style='display:inline; position: relative; top: 20px;'></div>" +
                  "<div id='modulesPerServiceParentEngagedModules' style='display:inline; position: relative; top: 20px;'></div>" +
                  "<div id='globleModules' style='display:inline; position: relative; top: 20px;'></div>" +
                  "</div></fieldset>";

    var body_xml = '<req:listOperationModulesRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <req:service_id>' + getServiceSpecificName() + '</req:service_id>\n' +
                   ' <req:operation_id>' + operationName + '</req:operation_id>\n' +
                   ' </req:listOperationModulesRequest>\n';

    objDiv.innerHTML = strHTML;
    showOnlyOneMain(objDiv);

    var callURL = serverURL + "/" + MODULE_ADMIN_SERVER_URL ;
    send("listOperationModules", body_xml, "", callURL, "", false, engageModulePerOperationCombo);

}

function engageModulePerOperationCombo() {
    if (!onError()) {
        return;
    }

    var xsltFileName = "list_engaged_modules_per_operation.xsl";
    var objDiv = document.getElementById("modulesPerOperation");
    var data = getBody(xhReq.responseXML);
    processXML(data, xsltFileName, objDiv);

    var body_xml = '<req:listServiceModulesRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <req:serviceName>' + getServiceSpecificName() + '</req:serviceName>\n' +
                   ' </req:listServiceModulesRequest>\n';

    var callURL = serverURL + "/" + "ModuleAdmin" + "/" ;
    send("listServiceModules", body_xml, "", callURL, "", false, engageModullePerOperationComboCallback);
}

function engageModullePerOperationComboCallback() {
    if (!onError()) {
        return;
    }
    var xsltFileName = "list_engaged_modules_per_operation.xsl";
    var objDiv = document.getElementById("modulesPerService");
    var data = getBody(xhReq.responseXML);
    processXML(data, xsltFileName, objDiv);

    getGlobalModuleCombo(document.getElementById("engageModulePerOperationCombo"), "cmbEngageModulePerOperationCombo");
}

function getGlobalModuleCombo(cmbSpan, cmbName) {
    moduleSpanToUse = cmbSpan;
    moduleComboName = cmbName;
    //    alert("Global module getting function called");

    var body_xml = '<ns1:listModules  xmlns:ns1="http://org.apache.axis2/xsd"/>\n';

    var callURL = serverURL + "/" + MODULE_ADMIN_STRING + "/" + "listModules";
    send("listModules", body_xml, "", callURL, "", false, getGlobalModuleComboCallback);

}

function getGlobalModuleComboCallback() {
    if (!onError()) {
        return;
    }
    var data = getBody(xhReq.responseXML);

    //    alert("XSL = " + (new XMLSerializer()).serializeToString(data));

    var strHTML = "<select id='" + moduleComboName + "'>";
    var rets = data.getElementsByTagName("return");
    var len = rets.length;
    var count;
    var moduleVersion;
    for (count = 0; count < len; count++) {
        if (rets[count].getElementsByTagName("moduleversion")[0].firstChild != null) {
            moduleVersion = rets[count].getElementsByTagName("moduleversion")[0].firstChild.nodeValue;
        } else {
            moduleVersion = "";
        }
        displayModuleVersion = (moduleVersion == "" ? "":("-" + moduleVersion));
        strHTML += "<option value='" +
                   rets[count].getElementsByTagName("moduleid")[0].firstChild.nodeValue + '||' +
                   moduleVersion + "'>" + rets[count].getElementsByTagName("modulename")[0].firstChild.nodeValue +
                   displayModuleVersion + "</option>\n";
    }
    strHTML += "</select>"
    moduleSpanToUse.innerHTML = strHTML;

    //globally engage

    body_xml = '<req:listGloballyEngagesModulesRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
               ' </req:listGloballyEngagesModulesRequest>\n';

    callURL = serverURL + "/" + "ModuleAdmin" + "/";
    send("listGloballyEngagesModules", body_xml, "", callURL, "", false, listGloballyEngageModulesCallback);

}

function listGloballyEngageModulesCallback() {
    if (!onError()) {
        return;
    }

    var xsltFileName = "list_engaged_modules_per_service.xsl";
    var objDiv = document.getElementById("globleModules");
    var data = getBody(xhReq.responseXML);
    processXML(data, xsltFileName, objDiv);

    //Operation's Parent's Parent module Listing

    var body_xml = '<req:listOperationsParentParentEngagedModulesRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   '<serviceName>' + getServiceSpecificName() + '</serviceName>\n' +
                   '<operationName>' + lastOperationUsed + '</operationName>\n' +
                   '</req:listOperationsParentParentEngagedModulesRequest>\n';

    callURL = serverURL + "/" + "ModuleAdmin" + "/";
    send("listOperationsParentParentEngagedModules", body_xml, "", callURL, "", false,
            listOperationsParentParentEngagedModulesCallback);


}

function listOperationsParentParentEngagedModulesCallback() {
    if (!onError()) {
        return;
    }

    var xsltFileName = "list_engaged_modules_per_service.xsl";
    var objDiv = document.getElementById("modulesPerServiceParentEngagedModules");
    var data = getBody(xhReq.responseXML);
    processXML(data, xsltFileName, objDiv);


}

function engageModulePerOperationExec(operationName, moduleName) {
    var moduleVersion = moduleName.substring(moduleName.indexOf('||') + 2, moduleName.length);
    moduleName = moduleName.substring(0, moduleName.indexOf('||'));
    setOperationName = operationName;

    var body_xml = '<req:engageModuleForOperationRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <req:moduleid>' + moduleName + '</req:moduleid>\n' +
                   ' <req:moduleversion>' + moduleVersion + '</req:moduleversion>\n' +
                   ' <req:service_id>' + getServiceSpecificName() + '</req:service_id>\n' +
                   ' <req:service_version></req:service_version>\n' +
                   ' <req:operation_id>' + operationName + '</req:operation_id>\n' +
                   ' </req:engageModuleForOperationRequest>\n';

    var callURL = serverURL + "/" + "ModuleAdmin" + "/" ;
    send("engageModuleForOperation", body_xml, "", callURL, "", false, engageModulePerOperationCallBack);


}
function engageModulePerOperationCallBack() {
    if (!onError()) {
        return;
    }

    var data = getBody(xhReq.responseXML);
    var text = data.getElementsByTagName('return')[0];

    alertMessage(text.firstChild.nodeValue);

    engageModulePerOperation(lastOperationUsed);
}

// disengaging modules from operation
function disengageModuelfromOperationExec(moduleName) {
    // gettting all the values from engageModulePerOperationExec
    var moduleVersion;
    var moduleNameid;
    if (moduleName.indexOf('-') > 0) {
        moduleVersion = moduleName.substring(moduleName.indexOf('-') + 1, moduleName.length);
        moduleNameid = moduleName.substring(0, moduleName.indexOf('-'));
    } else {
        moduleVersion = "";
        moduleNameid = moduleName;
    }

    var body_xml = '<req:disengageModuleFromOperationRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <req:moduleid>' + moduleNameid + '</req:moduleid>\n' +
                   ' <req:moduleversion>' + moduleVersion + '</req:moduleversion>\n' +
                   ' <req:service_id>' + getServiceSpecificName() + '</req:service_id>\n' +
                   ' <req:service_version></req:service_version>\n' +
                   ' <req:operation_id>' + lastOperationUsed + '</req:operation_id>\n' +
                   ' </req:disengageModuleFromOperationRequest>\n';

    var callURL = serverURL + "/" + "ModuleAdmin" + "/" ;
    send("disengageModuleFromOperation", body_xml, "", callURL, "", false, disengageModuleFromOperationCallBack);

}

function disengageModuleFromOperationCallBack() {
    if (!onError()) {
        return;
    }
    alertMessage("Module was disengaged from operation successfully.");
    engageModulePerOperation(lastOperationUsed);
}

// disengaging modules from operation
function disengageModuelfromServiceExec(moduleName) {
    // gettting all the values from engageModulePerOperationExec
    var moduleVersion;
    var moduleNameid;
    if (moduleName.indexOf('-') > 0) {
        moduleVersion = moduleName.substring(moduleName.indexOf('-') + 1, moduleName.length);
        moduleNameid = moduleName.substring(0, moduleName.indexOf('-'));
    } else {
        moduleVersion = "";
        moduleNameid = moduleName;
    }

    var body_xml = '<req:disengageModuleFromService xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <req:moduleid>' + moduleNameid + '</req:moduleid>\n' +
                   ' <req:moduleversion>' + moduleVersion + '</req:moduleversion>\n' +
                   ' <req:service_id>' + getServiceSpecificName() + '</req:service_id>\n' +
                   ' <req:service_version></req:service_version>\n' +
                   ' </req:disengageModuleFromService>\n';

    var callURL = serverURL + "/" + "ModuleAdmin" + "/" ;
    send("disengageModuleFromService", body_xml, "", callURL, "", false, disengageModuelfromServiceCallBack);

}

function disengageModuelfromServiceCallBack() {
    if (!onError()) {
        return;
    }
    alertMessage("Module was disengaged from service successfully.");
    setTimeout(function() {
        engageModulePerService(getServiceSpecificName());
    }, 1000);
    //    engageModulePerService(getServiceSpecificName());

}
//todo
function addServiceSpecificParameters() {
    var newParam = getUserInput();
    if (newParam != null) {
        processServiceOperationParameterConfigEntry(
                lastUsedServiceId,
                serviceSpecificName,
                newParam[0],
                newParam[1], getServiceSpecficParametersForConfig);
    }
}

//todo service level operations
function processMultipleServiceOperationParameterConfigEntry(serviceId,
                                                             parameterNamesObj,
                                                             parameterValueObj) {
    var paramElements = '';
    for (var i = 0 ; i < parameterNamesObj.length; i++) {
        paramElements += '<parameter locked="false" name="' + parameterNamesObj[i] + '"><![CDATA[' + parameterValueObj[i] +']]></parameter>\n';
    }
    var body_xml = '<ns1:setServiceParameters xmlns:ns1="http://org.apache.axis2/xsd">' +
                   '<ns1:serviceId>' + serviceId + '</ns1:serviceId>' +
                   '<ns1:serviceVersion>' + serviceId + '</ns1:serviceVersion>' +
                   paramElements +
                   '</ns1:setServiceParameters>';

    var callURL = serverURL + "/" + "ServiceAdmin";

    send("setServiceParameters", body_xml, "", callURL, "", false, processMultipleServiceOperationParameterConfigEntryCallback);


}

function processMultipleServiceOperationParameterConfigEntryCallback() {
    if (!onError()) {
        return;
    }

    alertMessage("Service parameters were successfully updated.");
    getServiceSpecficParametersForConfig(lastUsedServiceId);

}

//add a single operation parameter entry
function processServiceOperationParameterConfigEntry(
        serviceId,
        serviceVersion,
        parameterName,
        parameterValue, service_callback) {

    if (!parseParameterName(parameterName)) {
        alertMessage("Parameter name contains an invalid character");
        return false;
    }


    var body_xml = '<ns1:setServiceParameterRequest xmlns:ns1="http://org.apache.axis2/xsd">' +
                   '<ns1:service_id>' + serviceId + '</ns1:service_id>' +
                   '<ns1:service_version>' + serviceId + '</ns1:service_version>' +
                   '<parameter locked="false" name="' + parameterName + '"><![CDATA[' + parameterValue + ']]></parameter>' +
                   '</ns1:setServiceParameterRequest>';

    var callURL = serverURL + "/" + "ServiceAdmin";
    //update the information in operation display page
    send("setServiceParameter", body_xml, "", callURL, "", false, service_callback);
}
//end of  processSingleOperationParameterConfigEntry

//display the messages for the modules
function updateServiceInfoDisplay(message) {
    document.getElementById('serviceConfigUpdate').innerHTML = message;
}

//todo operation level
function processOperationParameterConfigUpdate(arrayOfNames, arrayOfValues) {

    processMultipleOperationParameterConfigEntry(lastUsedServiceId,serviceOperationParameters,arrayOfNames,arrayOfValues);

}
//todo
function processServiceOperationParameterConfigUpdate(arrayOfNames, arrayOfValues) {
    processMultipleServiceOperationParameterConfigEntry(lastUsedServiceId,arrayOfNames,arrayOfValues);
}

function completeServiceFileUpload() {
    cursorWait();
    showAARGenerationCompleteMsg("Archive was successfully uploaded.\n" +
                                 "This page will be auto refreshed shortly.");
}

function serviceParameters(serviceId, serviceVersion) {
    lastUsedServiceId = serviceId;
    lastUsedServiceVersion = serviceVersion;

    var xsltFileName = "list_service_param.xsl";
    var body_xml = '<req:getServiceParametersRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <req:service_id>' + serviceId + '</req:service_id>\n' +
                   ' <req:service_version>' + serviceVersion + '</req:service_version>\n' +
                   ' </req:getServiceParametersRequest>\n';


    var callURL = serverURL + "/" + "ServiceAdmin" + "/" ;
    send("getServiceParameters", body_xml, xsltFileName, callURL, document.getElementById("divServiceParameters"), false);

}

//faulty services

function listFaultyArchives() {
    var xsltFileName = "service_faults.xsl";
    var body_xml = '<req:getFaultyServiceArchivesRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' </req:getFaultyServiceArchivesRequest>\n';

    var callURL = serverURL + "/" + "ServiceAdmin" ;
    send("getFaultyServiceArchives", body_xml, xsltFileName, callURL,
            document.getElementById("divFaultyServices"), false);


}

function deleteFaultyService(faultServicePath) {
    var delete_to = confirm("Do you really want to Delete this Faulty Service ?");
    if (delete_to == true) {
        var body_xml = '<req:deleteFaultyServiceArchiveRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                       ' <req:archiveName>' + faultServicePath + '</req:archiveName>\n' +
                       ' </req:deleteFaultyServiceArchiveRequest>\n';

        var callURL = serverURL + "/" + "ServiceAdmin" ;
        send("deleteFaultyServiceArchive", body_xml, "", callURL, "", false, deleteFaultyServiceCallback);
    } else {
        //        alertMessage("Aborted Deletion.")
        return false;
    }

}

function deleteFaultyServiceCallback() {
    if (!onError()) {
        return;
    }
    cursorWait();
    setTimeout("showAARGenerationCompleteMsg('The Faulty Service has been successfully deleted !.')",
            1000);
}


// Stub generation
function getClassListFromArchive(archiveId) {
    genFileKey = archiveId;

    var dynamicServiceObj = document.getElementById('divDynamicService');
    showOnlyOneMain(dynamicServiceObj);

    var xsltFileName = "class_selection_wizard.xsl";
    var body_xml = '<req:getClassNamesRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   ' <req:archiveId>' + genFileKey + '</req:archiveId>\n' +
                   ' </req:getClassNamesRequest>\n';

    var callURL = serverURL + "/" + "ServiceAdmin" ;
    send("getClassNames", body_xml, xsltFileName, callURL,
            document.getElementById("divDynamicService"), false);
}
function generateAARSelectClasses() {
    var classes = document.getElementsByName("chkClasses");
    var arrayString = '';
    var isClassSelected = false;
    for (var i = 0; i < classes.length; i++) {
        if (classes[i].checked) {
            isClassSelected = true;
            arrayString += ' <req:serviceClasses>' + classes[i].value + '</req:serviceClasses>\n';
        }
    }
    if (!isClassSelected) {
        alertWarning("Please select at least one service class");
        return;
    }

    var body_xml = '<req:createAndDeployServiceRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   '<req:archiveId>' + genFileKey + '</req:archiveId>\n' +
                   arrayString +
                   '</req:createAndDeployServiceRequest>\n';

    //    alert(body_xml);
    var callURL = serverURL + "/" + "ServiceAdmin" ;
    send("createAndDeployService", body_xml, "",
            callURL, document.getElementById("divDynamicService"), false, completeAARGenerationCB);
}

function completeAARGenerationCB() {
    if (!onError()) {
        return;
    }
    cursorWait();
    setTimeout("showAARGenerationCompleteMsg('The service archive was successfully generated.')",
            10000);
}


function selectAll(checkboxes, select) {
    for (var i = 0; i < checkboxes.length; i++) {
        checkboxes[i].checked = select;
    }
}

function dynamicClientGeneration() {

   var body_xml =  '<req:generateAjaxClient xmlns:req="http://services.codegen.wsas.wso2.org">\n' +
                   '<serviceName>' + getServiceSpecificName() + '</serviceName>\n' +
                   '</req:generateAjaxClient>\n';

    var callURL = serverURL + "/" + "AjaxClientGeneratorService" ;
    cursorWait();
    send("generateAjaxClient", body_xml, "", callURL, "", false, dynamicClientGenerationCallBack);

}

function dynamicClientGenerationCallBack() {
    if (!onError()) {
        return;
    }
    //response will be a link and it will call the download dialog
    var data = getBody(xhReq.responseXML);

    var rets = data.getElementsByTagName("return");

    //    alert('return value' + rets[0].firstChild.nodeValue);
    //    dynamicClientResponseVisibility(URL + rets[0].firstChild.nodeValue);
    //    window.location = URL + rets[0].firstChild.nodeValue;
    cursorClear();
    
    dynamicClientResponseVisibilityAllBrowsers(data);
}


function dynamicClientGenerationMetaInfo() {
    var xsltFileName = "";
    var body_xml = '<req:listServicesAndPortsRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   '<req:serviceName>' + getServiceSpecificName() + '</req:serviceName>\n' +
                   ' </req:listServicesAndPortsRequest>\n';

    var callURL = serverURL + "/" + "WSDLInfoService" + "/" ;
    send("listServicesAndPorts", body_xml, "", callURL, "", false, dynamicClientGenerationMetaInfoCallback);

}

function dynamicClientGenerationMetaInfoCallback() {
    if (!onError()) {
        return;
    }
    callbackhelper("dynamic_client_meta_info.xsl", document.getElementById("divDynamicClientGeneration"));
    showdynamicClientMetaInfo(document.getElementById('dynamicClientMetaInfo'));
}


function dynamicClientResponseVisibility(url) {
    var objDiv = document.getElementById("divDynamicClientResponse");
    var headerElement = "<h3><a href='#' onClick='javascript:showServiceInitializer(); return false;'>Services</a>&nbsp;&gt;&nbsp;<a href='#' onClick='javascript:listServiceData(\"" + getServiceSpecificName() + "\"); return false;'>" + getServiceSpecificName() + "</a>" + "&nbsp;&gt;&nbsp;Dynamic Client" + "</h3>";
    var dynamicClientInnerFrame = "<div style=\"height:600px;position:relative;\"><form>" +
                                  "<iframe id=\"divDynamicClientResponseInnerFrame\" frameborder=\"0\"  style=\"width:70%;height:100%;position:absolute;\" scrolling=\"auto\"></iframe>" +
                                  "</div>";
    var temp = "<p/>";
    objDiv.innerHTML = headerElement + dynamicClientInnerFrame + temp;
    document.getElementById("divDynamicClientResponseInnerFrame").src = url;

    showOnlyOneMain(objDiv);
}


function dynamicClientResponseVisibilityAllBrowsers(data) {

    var xsltFileName = "try_it.xsl";
    var objDiv = document.getElementById('divTryit');
    processXML(data, xsltFileName, objDiv);
    showOnlyOneMain(objDiv);

}

function wsdlForDynamicClient() {
    window.open(SERVICE_CONTEXT + '/' + getServiceSpecificName() + '?wsdl');
}


function startServices(thisObj,index) {

    if (thisObj && index) {
        renderSelectedMenuItem(thisObj,index);
        gatherHistoryObject(thisObj.id, index);
    }

    var body_xml = '<req:getHttpPortRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   '</req:getHttpPortRequest>\n';

    var callURL = serverURL + "/" + "ServerAdmin" ;
    send("getHttpPort", body_xml, "", callURL, "", false, startServicesCallback);

}

function startServicesCallback() {
    if (!onError()) {
        return;
    }

    var data = getBody(xhReq.responseXML);

    var httpPort = data.getElementsByTagName('return')[0].firstChild.nodeValue;

    defaultHttpPort = httpPort;

    openWindowHTTPBrowserURL();

    //Listing all the service_groups

    showServiceInitializer();

}

function showServiceInitializer() {

    var tmpTransformationNode;

	/* The checking for the existance for window.XMLHttpRequest to figure out the browser
	and the functionality was dropped since the new version of IE has this object. */
    if (isIE()) {
        tmpTransformationNode = new ActiveXObject("Microsoft.XmlDom");
        var sXml = "<initializeService></initializeService>";
        tmpTransformationNode.loadXML(sXml);
    } else {
        tmpTransformationNode =
        document.implementation.createDocument("", "initializeService", null);
    }

    processXML(tmpTransformationNode, "list_services.xsl", document.getElementById("divListServiceGroups"));
    showOnlyOneMain(document.getElementById("divListServiceGroups"));


    listServiceGroups();
    if (listServiceGroupsRequestInterval == 0) {
        listServiceGroupsRequestInterval = setInterval('listServiceGroups()', SERVICE_REFRESH_TIME);
    }
}

function openWindowHTTPBrowserURL() {

    var isPortFound = false;

    browserHref = self.location.href;

    var transientBrowserString = browserHref.substring(browserHref.indexOf('://') + 3, browserHref.length);

    if (transientBrowserString.lastIndexOf(':') != -1) {
        // has port
        isPortFound = true;
        defaultBrowserHost = transientBrowserString.substring(0, transientBrowserString.lastIndexOf(':'));
    } else {
        defaultBrowserHost = transientBrowserString.substring(0, transientBrowserString.indexOf('/'));
    }


    /*var transitString = browserHref.substring(browserHref.lastIndexOf('://') +
                                             3, browserHref.length);*/
    var transitString = defaultURL.substring(defaultURL.lastIndexOf('://') +
                                             3, defaultURL.length);
    var wso2wsasRoot;
    if (transitString.lastIndexOf('/') != -1) {  // '/' root does exists
        wso2wsasRoot = transitString.substring(transitString.lastIndexOf('/') +
                                               1, transitString.length);
        defaultopenWindowHTTPURL =
        'http://' + defaultBrowserHost + ':' + defaultHttpPort + '/' +
        wso2wsasRoot;
    } else {
        if (isPortFound) {
            defaultopenWindowHTTPURL =
            'http://' + defaultBrowserHost + ':' + defaultHttpPort;
        } else {
            defaultopenWindowHTTPURL =
            'http://' + defaultBrowserHost;
        }
    }

}


function openWindowHTTP(value) {
    window.open(defaultopenWindowHTTPURL + SERVICE_CONTEXT + '/' + value);
}

function openExtraWindowHTTP(firstValue, lastValue) {
    window.open(defaultopenWindowHTTPURL+ "/" + firstValue + SERVICE_CONTEXT + "/" + lastValue);
}


function getExposedTransports(serviceId) {

    /*stopping the refreshing first */
    stoppingRefreshingMethodsHook();

    var body_xml = '<req:getExposedTransportsRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   '<serviceId>' + serviceId + '</serviceId>\n' +
                   '</req:getExposedTransportsRequest>\n';

    var callURL = serverURL + "/" + "ServiceAdmin" ;
    send("getExposedTransports", body_xml, "", callURL, "", false, getExposedTransportsCallback);

}

function getExposedTransportsCallback() {
    if (!onError()) {
        return;
    }

    //        alert("Response" + (new XMLSerializer()).serializeToString(getBody(xhReq.responseXML)));
    callbackhelper("list_transport.xsl", document.getElementById("divListTransports"));

    // breadcrumbs setting
    showListTransportDiv(document.getElementById('breadcumbsgetExposedTransportsHeader'));

    listSystemTransports();

}

function listSystemTransports() {

    var body_xml = '<req:listTransportsRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   '</req:listTransportsRequest>\n';

    var callURL = serverURL + "/" + "TransportAdmin" ;
    send("listTransports", body_xml, "", callURL, "", false, listSystemTransportsCallback);

}

function listSystemTransportsCallback() {
    if (!onError()) {
        return;
    }

    //    alert("Response" + (new XMLSerializer()).serializeToString(getBody(xhReq.responseXML)));

    var txSelectionCombo = document.getElementById('transportSelectionCombo');

    var data = getBody(xhReq.responseXML);

    var protocols = data.getElementsByTagName('protocol');

    for (var i = 0; i < protocols.length; i++) {
        txSelectionCombo.options[i] = new
        Option(protocols[i].firstChild.nodeValue);
        txSelectionCombo.options[i].value = protocols[i].firstChild.nodeValue;
    }

}

function addNewTransportForService(obj) {
    //selecting the value from combo
    var protocol = obj[obj.selectedIndex].value;

    var body_xml = '<req:exposeServiceViaTransportRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   '<serviceId>' + getServiceSpecificName() + '</serviceId>\n' +
                   '<transportProtocol>' + protocol + '</transportProtocol>\n' +
                   '</req:exposeServiceViaTransportRequest>\n';

    var callURL = serverURL + "/" + "ServiceAdmin" ;
    send("addTransportBinding", body_xml, "", callURL, "", false, addNewTransportForServiceCallback);
}

function addNewTransportForServiceCallback() {
    if (!onError()) {
        return;
    }
    showResponseMessage(xhReq);
    getExposedTransports(getServiceSpecificName());
}

function removeTransportBinding(protocol) {

    var conf = confirm("Do you want to remove the " + protocol +
                       " transport binding for this service?");
    if (!conf) {
        return true;
    }
    var body_xml = '<req:removeTransportBindingRequest xmlns:req="http://org.apache.axis2/xsd">\n' +
                   '<serviceId>' + getServiceSpecificName() + '</serviceId>\n' +
                   '<transportProtocol>' + protocol + '</transportProtocol>\n' +
                   '</req:removeTransportBindingRequest>\n';

    var callURL = serverURL + "/" + "ServiceAdmin" ;
    send("removeTransportBinding", body_xml, "", callURL, "", false, removeTransportBindingCallback);
}

function removeTransportBindingCallback() {
    if (!onError()) {
        return;
    }
    showResponseMessage(xhReq);
    getExposedTransports(getServiceSpecificName());
}

function openExtraWindowHTTPForWebResources(firstValue, lastValue) {

    /*stopping the refreshing first */
    stoppingRefreshingMethodsHook();

    window.open(defaultopenWindowHTTPURL + '/' + firstValue + "/" + lastValue);
}

var SPRING_BEANS_UUID;
var SPRING_CONTEXT_UUID;
function getSpringBeansFromArchive(springBeansUUID,springContextUUID) {
    SPRING_BEANS_UUID = springBeansUUID;
    SPRING_CONTEXT_UUID = springContextUUID;
    var body_xml = '<req:getSpringBeanNames xmlns:req="http://org.apache.axis2/xsd">\n' +
                   '<springContextId>' + springContextUUID + '</springContextId>\n' +
                   '<springBeanId>' + springBeansUUID + '</springBeanId>\n' +
                   '</req:getSpringBeanNames>\n';

    var callURL = serverURL + "/" + "ServiceAdmin" ;
    send("getSpringBeanNames", body_xml, "", callURL,"", false,getSpringBeansFromArchiveCallback);


}

function getSpringBeansFromArchiveCallback() {
    if (!onError()) {
        return;
    }

    callbackhelper("spring_beans_selection_wizard.xsl",document.getElementById("divBeanGenerationWizard"));

}

function generateBeansForAARSelectClasses(uuid) {
    var classes = document.getElementsByName("chkBeans");
    var arrayString = '';
    var isClassSelected = false;
    for (var i = 0; i < classes.length; i++) {
        if (classes[i].checked) {
            isClassSelected = true;
            arrayString += ' <beanClasses>' + classes[i].value + '</beanClasses>\n';
        }
    }
    if (!isClassSelected) {
        alertWarning("Please select at least one Spring bean");
        return;
    }

    var body_xml = '<req:createAndDeploySpringBean xmlns:req="http://org.apache.axis2/xsd">\n' +
                   '<springContextId>' + uuid + '</springContextId>\n' +
                   '<springBeanId>' + SPRING_BEANS_UUID + '</springBeanId>\n' +
                   arrayString +
                   '</req:createAndDeploySpringBean>\n';

    //    alert(body_xml);
    var callURL = serverURL + "/" + "ServiceAdmin" ;
    send("createAndDeploySpringBean", body_xml, "",
            callURL, document.getElementById("divDynamicService"), false, completeAARGenerationCB);
}

function codegenUnwrappingSelectorHelper(obj) {
    var uwSelect = document.getElementById('unwrap');

    if (obj.options[obj.selectedIndex].value == "none") {
        uwSelect.options[1].disabled = true;
    } else {
        uwSelect.options[1].disabled = false;
    }
}





















