<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:template match="initializeService" >
        <table>
        	<tr>
        		<td><h2>Service &amp; Service Group Management</h2></td>
				<td valign="top">&#160;&#160;&#160;&#160;
					<a id="rss_link">
						<xsl:attribute name="href">#</xsl:attribute>
						<xsl:attribute name="onClick">javascript:openWindowHTTP('rss');return false;</xsl:attribute>
						<xsl:attribute name="target">_blank</xsl:attribute>
						<xsl:attribute name="title">WSO2 Web Services Application Server v1.1 RSS 2.0</xsl:attribute>
						<xsl:attribute name="alt">WSO2 Web Services Application Server v1.1 RSS 2.0</xsl:attribute>
						<xsl:text>&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;</xsl:text>
					</a>&#160;&#160;&#160;&#160;
					<a id="atom_link">
						<xsl:attribute name="href">#</xsl:attribute>
                        <xsl:attribute name="onClick">javascript:openWindowHTTP('atom');return false;</xsl:attribute>
                        <xsl:attribute name="target">_blank</xsl:attribute>
						<xsl:attribute name="title">WSO2 Web Services Application Server v1.1n Atom 1.0</xsl:attribute>
						<xsl:attribute name="alt">WSO2 Web Services Application Server v1.1n Atom 1.0</xsl:attribute>
						<xsl:text>&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;&#160;</xsl:text>
					</a>
				</td>
			</tr>
        </table>
        
        <fieldset style="border:none;">
        <div id="listServicesInformation">
            <p>Refreshing service list...</p>
        </div>

        <div id="faultyServices" style="display:none;"></div>
        <p>&#160;</p>
            <div id="formsetWrapper">
                <div id="formset">
                    <xsl:call-template name="serviceUploadTemplate"/>
                    <xsl:call-template name="springUploadTemplate"/>
                </div>
            </div>

        </fieldset>
    </xsl:template>

    <xsl:template name="serviceUploadTemplate">
            <form method="post"  name="serviceUpload" action="fileupload/service" enctype="multipart/form-data" target="globalIFrame">
                <fieldset>
                    <legend>Upload a New Service (.aar, .jar or .zip)</legend>
                    <div>
                        <label for="module_a">Service archive (.aar,.jar,.zip) :</label><input type="file" id="filename" name="filename" size="50"/>
                    </div>
                    <div class="buttonrow">
                        <input name="upload" type="submit" value=" Upload ">
                            <xsl:attribute name="onclick">javascript: if (document.serviceUpload.filename.value == '') { alertWarning('Please select a file before clicking upload.'); return false;} else { stoppingRefreshingMethodsHook(); return true;}</xsl:attribute>
                        </input>
                    </div>
                </fieldset>
             </form>
    </xsl:template>

    <xsl:template name="springUploadTemplate">
        <form method="post"  name="springUpload" action="fileupload/spring" enctype="multipart/form-data" target="globalIFrame">
                <fieldset>
                    <legend>Upload a New Spring Service (.xml and .jar)</legend>
                    <div for="spring_a">
                        <label>Spring Context (.xml) :</label><input type="file" id="springContext" name="springContext" size="50"/>
                    </div>
                    <div><br/></div>
                    <div for="sprng_b">
                        <label>Spring Beans (.jar) :</label><input type="file" id="springBeans" name="springBeans" size="50"/>
                    </div>
                    <div class="buttonrow">
                        <input name="upload" type="submit" value=" Upload ">
                            <xsl:attribute name="onclick">javascript: if (document.springUpload.springContext.value == '' || document.springUpload.springBeans.value == '') { alertWarning('Please select required fields to upload spring service'); return false;} else { stoppingRefreshingMethodsHook(); return true;}</xsl:attribute>
                        </input>
                    </div>
                </fieldset>
          </form>
    </xsl:template>
</xsl:stylesheet>
