<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <xsl:template match="ns1:listServicesAndPortsResponse" xmlns:ns1="http://org.apache.axis2/xsd">
        <!--  Link header to be populated by java script -->
        <div id="stubGenMetaInfo"></div>
		<div id="formset">
			<form>
				<fieldset>
					<legend>Stub Generation options</legend>
                    <xsl:for-each select="return">
                    <div>
                         <label>Service Binding</label><xsl:value-of select="service"/>
                    </div>

					<div>
						<label>Port</label>
                        <select id="portSelectBox" tabindex="1">
                            <xsl:for-each select="ports">
                                <option>
                                    <xsl:attribute name="value"><xsl:value-of select="."/></xsl:attribute>
                                    <xsl:value-of select="."/>
                                </option>
                            </xsl:for-each>
                        </select>
					</div>

                    </xsl:for-each>

                    <div id='formset'>
                        <form>
                            <div>
                                <label>Package Name <font color='red'>*</font></label>
                                <input type='text' id='pakageName' size='40' value='org.wso2.wsas.client' tabindex="2"/>
                            </div>
                            <div>
                                <label>Invocation Style</label>
                                <select id='invocationStyle' tabindex="3">
                                    <option value='both'>Both</option>
                                    <option value='a'>Asynchronous</option>
                                    <option value='s'>Synchronous</option>
                                </select>
                            </div>
                            <div>
                                <label>Databinding</label>
                                <select id='databindingMethod' tabindex="4">
                                    <xsl:attribute name="onchange">javascript:codegenUnwrappingSelectorHelper(this);return false;</xsl:attribute>
                                    <option value='adb'>ADB</option>
                                    <option value='xmlbeans'>XMLBeans</option>
                                    <option value='none'>NONE</option>
                                </select>
                            </div>
                            <div>
                                <label>Unpack Classes</label>
                                <select id='unpackClasses' tabindex="5">
                                    <option value='true'>True</option>
                                    <option value='false'>False</option>
                                </select>
                            </div>
                            <div>
                                <label>Unwrap</label>
                                <select id='unwrap' tabindex="6">
                                    <option value='false'>False</option>
                                    <option value='true'>True</option>
                                </select>
                            </div>
                            <div>
                                <label>Generate Testcase</label>
                                <select id='generateTestCases' tabindex="7">
                                    <option value='false'>False</option>
                                    <option value='true'>True</option>
                                </select>
                            </div>
                        </form>
                    </div>

                    <div class='buttonrow'>
                    <input type='button'  value='Generate' tabindex="8">
                        <xsl:attribute name="onClick">stubGenerationSOAPRequest(document.getElementById('pakageName'), document.getElementById('invocationStyle'), document.getElementById('generateTestCases'), document.getElementById('databindingMethod'), document.getElementById('unpackClasses'),'<xsl:value-of select="return/service"/>', document.getElementById('portSelectBox'),document.getElementById('unwrap'));return false;</xsl:attribute>
                    </input>
                    </div>

                </fieldset>
			</form>
		</div>
    </xsl:template>
</xsl:stylesheet>
