<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
	<xsl:output method="html" />

    <xsl:template match="ns1:getStatusResponse" xmlns:ns1="http://org.apache.axis2/xsd">

        <h2>WSO2 Web Services Application Server v1.1 Home</h2>
        <p>
            Welcome to the WSO2 Web Services Application Server v1.1 Management Console.
        </p>
        <div id="formset">
            <table class="styledLeft">
            <thead><tr><th colspan="2">System Summary</th></tr></thead>
            <xsl:for-each select="return">
                <tr>
                <td><strong>Server Name</strong></td>
                <td><xsl:value-of select="serverName"/></td>
                </tr>
                <tr>
                <td><strong>Server Version</strong></td>
                <td><xsl:value-of select="wso2wsasVersion"/></td>
                </tr>
                <tr>
                <td><strong>Server Start Time</strong></td>
                <td><xsl:value-of select="serverStartTime"/></td>
                </tr>
                <tr>
                <td><strong>System Up Time</strong></td>
                <td><xsl:value-of select="systemUpTime"/></td>
                </tr>
                <tr>
                <td><strong>Memory Allocated</strong></td>
                <td><xsl:value-of select="totalMemory/value"/><xsl:value-of select="totalMemory/unit"/></td>
                </tr>
                <tr>
                <td><strong>Memory Usage</strong></td>
                <td><xsl:value-of select="usedMemory/value"/><xsl:value-of select="usedMemory/unit"/></td>
                </tr>
                <thead><tr><th colspan="2">Service Summary</th></tr></thead>
                <tr>
                <td><strong>Total Request Count</strong></td>
                <td><xsl:value-of select="requestCount"/></td>
                </tr>
                <tr>
                <td><strong>Total Response Count</strong></td>
                <td><xsl:value-of select="responseCount"/></td>
                </tr>
                <tr>
                <td><strong>Total Fault Count</strong></td>
                <td><xsl:value-of select="faultCount"/></td>
                </tr>
                <tr>
                <td><strong>Active Services</strong></td>
                <td><xsl:value-of select="services"/></td>
                </tr>
            </xsl:for-each>
            </table>
        </div>
    </xsl:template>
</xsl:stylesheet>
