package org.wso2.wsas.sample.exchange.client;

import org.wso2.www.types.exchange.client.GetInfoResponse;
import org.wso2.www.types.exchange.client.MarketInfo;


public class ExchangeClientCallbackHandlerExt
    extends ExchangeClientCallbackHandler {
    boolean complete;

    public ExchangeClientCallbackHandlerExt(Object clientData) {
        super(null);
    }

    public boolean isComplete() {
        return complete;
    }

    private void setComplete(boolean complete) {
        this.complete = complete;
    }

    public void receiveErrorgetInfo(Exception e) {
        // Fill here with the code to handle the exception
        System.out.println(e.getMessage());
        setComplete(true);
    }

    public void receiveResultgetInfo(GetInfoResponse param11) {
        // Fill here with the code to handle the response
        System.out.println("\nResults");
        System.out.println("-------");

        MarketInfo marketInfo = param11.getMarketInfo();

        System.out.println("Average price          :" +
            marketInfo.getAvgPrice());
        System.out.println("Average price of trade :" +
            marketInfo.getAvgPriceOfTrade());
        System.out.println("Market cap             :" +
            marketInfo.getMarketCap());
        System.out.println("Total trader           :" +
            marketInfo.getTotalTraded());
        System.out.println("\n\n\n");

        setComplete(true);
    }
}
